<template>
  <div>
    <duplicated-schedule v-model="duplicateDialog" @accept="duplicate" />
    <v-row justify="space-between" align="end" class="mb-5">
      <v-col cols="12" md="auto">
        <!-- <p class="headline"></p> -->
        <div class="text-h4">
        Disponibilidad
        </div>
      </v-col>
      <v-col cols="12" md="auto">
        <v-row no-gutters>
          <v-btn
            color="primary"
            rounded
            outlined
            class="mr-2"
            :disabled="!enableCalendar"
            @click="getEvents"
          >
            cancelar
          </v-btn>
          <v-btn
            color="primary"
            rounded
            v-if="!enableCalendar"
            @click="enable()"
          >
            <v-icon left>mdi-pencil</v-icon>editar
          </v-btn>
          <v-btn color="primary" rounded v-else @click="save()">guardar </v-btn>
        </v-row>
      </v-col>
    </v-row>
    <v-row class="fill-height">
      <v-col>
        <v-sheet height="64">
          <v-toolbar flat>
            <v-btn
              outlined
              class="mr-4"
              color="grey darken-2"
              @click="setToday"
            >
              Hoy
            </v-btn>
            <v-btn fab text small color="grey darken-2" @click="prev">
              <v-icon small> mdi-chevron-left </v-icon>
            </v-btn>
            <v-btn fab text small color="grey darken-2" @click="next">
              <v-icon small> mdi-chevron-right </v-icon>
            </v-btn>
            <v-toolbar-title v-if="$refs.calendar" class="text-capitalize">
              {{ $refs.calendar.title }}
            </v-toolbar-title>
            <v-spacer />
            <v-menu bottom right>
              <template #activator="{ on, attrs }">
                <v-btn outlined color="grey darken-2" v-bind="attrs" v-on="on">
                  <span>{{ typeToLabel[type] }}</span>
                  <v-icon right> mdi-menu-down </v-icon>
                </v-btn>
              </template>
              <v-list>
                <v-list-item @click="type = 'day'">
                  <v-list-item-title>Día</v-list-item-title>
                </v-list-item>
                <v-list-item @click="type = 'week'">
                  <v-list-item-title>Semana</v-list-item-title>
                </v-list-item>
                <v-list-item @click="type = 'month'">
                  <v-list-item-title>Mes</v-list-item-title>
                </v-list-item>
                <v-list-item @click="type = '4day'">
                  <v-list-item-title>4 días</v-list-item-title>
                </v-list-item>
              </v-list>
            </v-menu>
          </v-toolbar>
        </v-sheet>
        <v-sheet :height="type === 'month' ? 600 : ''">
          <v-calendar
            ref="calendar"
            v-model="value"
            locale="es"
            :type="type"
            :interval-format="intervalFormat"
            interval-count="12"
            first-time="08:00"
            :events="events"
            :event-color="getEventColor"
            :event-ripple="false"
            event-overlap-mode="column"
            @change="getEvents"
            @click:event="showEvent"
            @mousedown:event="startDrag"
            @mousedown:time="startTime"
            @mousemove:time="mouseMove"
            @mouseup:time="endDrag"
            @mouseleave.native="cancelDrag"
          >
            <template #event="{ event, timed, eventSummary }">
              <div class="v-event-draggable">
                <v-icon
                  v-if="isEnable(event)"
                  small
                  dark
                  @click="removeEvent(event)"
                >
                  mdi-close
                </v-icon>
                <div v-html="eventSummary()" class="text-capitalize"></div>
              </div>
              <div
                v-if="timed && isEnable(event)"
                class="v-event-drag-bottom"
                @mousedown.stop="extendBottom(event)"
              />
              <selected-event
                v-model="selectedOpen"
                :key="key"
                :selectedEvent="selectedEvent"
                :eventColor="colors[1]"
                :selectedElement="selectedElement"
                @cancel="selectedOpen = false"
              />
            </template>
          </v-calendar>
        </v-sheet>
      </v-col>
    </v-row>
    <v-row>
      <v-col>
        <v-icon :color="colors[0]"> mdi-square </v-icon>
        <span class="mr-5"> Disponible </span>
        <v-icon :color="colors[1]"> mdi-square </v-icon>
        <span> Reservado </span>
      </v-col>
    </v-row>
  </div>
</template>
<script>
import { mapActions, mapState, mapGetters } from "vuex";
import DuplicatedSchedule from "@/components/calendar/DuplicateSchedule";
import SelectedEvent from "@/components/calendar/SelectedEvent";
import { getWeek } from "@/helpers/time";

export default {
  components: {
    DuplicatedSchedule,
    SelectedEvent,
  },
  data: () => ({
    key: 0,
    type: "week",
    typeToLabel: {
      month: "Mes",
      week: "Semana",
      day: "Día",
      "4day": "4 días",
    },
    value: "",
    events: [],
    colors: ["#4de08a", "#1a73e8"],
    selectedEvent: {},
    selectedElement: null,
    selectedOpen: false,
    dragEvent: null,
    dragStart: null,
    createEvent: null,
    createStart: null,
    extendOriginal: null,
    enableCalendar: false,
    duplicateDialog: false,
  }),
  computed: {
    ...mapState({
      availability: (state) => state.calendar.availability,
      loading: (state) => state.calendar.availability,
    }),
    ...mapGetters({
      myUserUuid: "auth/myUserUuid",
    }),
  },
  watch: {
    availability(val) {
      this.getEvents();
    },
  },
  mounted() {
    this.initialize();
  },
  methods: {
    enable() {
      this.enableCalendar = true;
    },
    save() {
      this.duplicateDialog = true;
    },
    startDrag({ event, timed }) {
      if (event && timed) {
        this.dragEvent = event;
        this.dragTime = null;
        this.extendOriginal = null;
      }
    },
    getWeek() {
      let curr = new Date();
      if (this.value) {
        curr = new Date(this.value);
        curr.setHours(curr.getHours() + 5);
      }
      let dateBegin = new Date(curr.setDate(curr.getDate() - curr.getDay()));
      let dateEnd = new Date(curr.setDate(curr.getDate() - curr.getDay() + 6));
      dateBegin = this.formatDateN(dateBegin);
      dateEnd = this.formatDateN(dateEnd);
      return { dateBegin, dateEnd };
    },
    initialize() {
      const specialistUuid = this.myUserUuid;
      const { dateBegin, dateEnd } = this.getWeek();
      this.getAvailability({ specialistUuid, dateBegin, dateEnd });
    },
    startTime(tms) {
      // this start dragging
      if (this.enableCalendar) {
        const mouse = this.toTime(tms);
        if (this.dragEvent && this.dragTime === null) {
          const start = this.dragEvent.start;
          this.dragTime = mouse - start;
        } else {
          this.createStart = this.roundTime(mouse);
          let event = {
            name: "disponible",
            start: this.createStart,
            end: this.createStart + 10 * 30 * 6000,
            state: 0,
            timed: true,
          };
          this.createEvent = event;
          this.events.push(this.createEvent);
        }
      }
    },
    formatDateN(d) {
      let ye = new Intl.DateTimeFormat("en", { year: "numeric" }).format(d);
      let mo = new Intl.DateTimeFormat("en", { month: "2-digit" }).format(d);
      let da = new Intl.DateTimeFormat("en", { day: "2-digit" }).format(d);
      return `${ye}-${mo}-${da}`;
    },
    extendBottom(event) {
      this.createEvent = event;
      this.createStart = event.start;
      this.extendOriginal = event.end;
    },
    mouseMove(tms) {
      const mouse = this.toTime(tms);
      if (
        this.dragEvent &&
        this.isEnable(this.dragEvent) &&
        this.dragTime !== null
      ) {
        const start = this.dragEvent.start;
        const end = this.dragEvent.end;
        const duration = end - start;
        const newStartTime = mouse - this.dragTime;
        const newStart = this.roundTime(newStartTime);
        const newEnd = newStart + duration;

        this.dragEvent.start = newStart;
        this.dragEvent.end = newEnd;
      } else if (this.createEvent && this.createStart !== null) {
        const mouseRounded = this.roundTime(mouse, false);
        const min = Math.min(mouseRounded, this.createStart);
        const max = Math.max(mouseRounded, this.createStart);

        this.createEvent.start = min;
        this.createEvent.end = max;
      }
    },
    endDrag() {
      this.dragTime = null;
      this.dragEvent = null;
      this.createEvent = null;
      this.createStart = null;
      this.extendOriginal = null;
    },
    cancelDrag() {
      if (this.createEvent) {
        if (this.extendOriginal) {
          this.createEvent.end = this.extendOriginal;
        } else {
          const i = this.events.indexOf(this.createEvent);
          if (i !== -1) {
            this.events.splice(i, 1);
          }
        }
      }
      this.createEvent = null;
      this.createStart = null;
      this.dragTime = null;
      this.dragEvent = null;
    },
    roundTime(time, down = true) {
      const roundTo = 30; // minutes
      const roundDownTime = roundTo * 60 * 1000;

      return down
        ? time - (time % roundDownTime)
        : time + (roundDownTime - (time % roundDownTime));
    },
    toTime(tms) {
      return new Date(
        tms.year,
        tms.month - 1,
        tms.day,
        tms.hour,
        tms.minute
      ).getTime();
    },
    getEventColor(event) {
      const eventColor = this.colors[event.state];
      const rgb = parseInt(eventColor.substring(1), 16);
      const r = (rgb >> 16) & 0xff;
      const g = (rgb >> 8) & 0xff;
      const b = (rgb >> 0) & 0xff;

      return event === this.dragEvent
        ? `rgba(${r}, ${g}, ${b}, 0.7)`
        : event === this.createEvent
        ? `rgba(${r}, ${g}, ${b}, 0.7)`
        : eventColor;
    },
    getEvents() {
      this.enableCalendar = false;
      const events = this.availability;
      const formatEvents = events.map((event) => {
        return {
          id: event.id,
          name: event.state === 0 ? "disponible" : "ocupado",
          start: new Date(event.startTime),
          end: new Date(event.endTime),
          state: event.state,
          timed: true,
          sessionId: event.sessionId || "1",
          patient: event.patient
            ? event.patient.name + " " + event.patient.fatherLastname
            : "",
        };
      });
      this.events = formatEvents;
    },
    intervalFormat(locale, getOptions) {
      return locale.time;
    },
    viewDay({ date }) {
      this.focus = date;
      this.type = "day";
    },
    setToday() {
      this.value = "";
      this.initialize();
    },
    prev() {
      this.$refs.calendar.prev();
      this.initialize();
    },
    next() {
      this.$refs.calendar.next();
      this.initialize();
    },
    isEnable(event) {
      return event.state !== 1 && this.enableCalendar;
    },
    showEvent({ nativeEvent, event }) {
      if (event.state === 1) {
        this.forceRender();
        const open = () => {
          this.selectedEvent = event;
          this.selectedElement = nativeEvent.target;
          setTimeout(() => (this.selectedOpen = true), 10);
        };
        if (this.selectedOpen) {
          this.selectedOpen = false;
          setTimeout(open, 10);
        } else {
          open();
        }
        nativeEvent.stopPropagation();
      }
    },
    removeEvent(selectedEvent) {
      const index = this.events.findIndex((event) => event === selectedEvent);
      if (index !== -1) {
        this.events.splice(index, 1);
      }
    },
    forceRender() {
      this.key += 1;
    },
    getSlices(start, end, state) {
      let slices = [];
      while (end > start) {
        let init = new Date(start.getTime());
        start = new Date(start.getTime() + 30 * 60 * 1000);
        slices.push({
          startTime: init,
          endTime: start,
          state,
        });
      }
      return slices;
    },
    async duplicate({ item, weeks }) {
      const specialistUuid = this.myUserUuid;
      const range = 10 * 30 * 6000;
      let availabilityDTOs = [];
      this.events.forEach((obj) => {
        const start = new Date(obj.start - 60 * 60 * 5000);
        const end = new Date(obj.end - 60 * 60 * 5000);
        if (end - start === range) {
          availabilityDTOs.push({
            state: obj.state,
            startTime: start,
            endTime: end,
          });
        } else {
          let slices = this.getSlices(start, end, obj.state);
          availabilityDTOs.push(...slices);
        }
      });
      const { dateBegin, dateEnd } = this.getWeek();
      const duplicatedWeeks = item === 1 ? weeks : 0;
      const payload = {
        availabilityDTOs,
        replicate: duplicatedWeeks,
        dateBegin,
        dateEnd,
      };
      const response = await this.registerAvailability({
        specialistUuid,
        payload,
      });
      if (response) {
        this.$notifier.showMessage({ content: "Disponibilidad modificada" });
      }
      this.initialize();
      this.duplicateDialog = false;
    },
    ...mapActions({
      registerAvailability: "calendar/registerAvailability",
      getAvailability: "calendar/getAvailability",
    }),
    isOverlapping(event) {
      const array = this.events;
      for (const i in array) {
        if (array[i].id != event.id) {
          if (
            !(
              Date(array[i].start) >= Date(event.end) ||
              Date(array[i].end) <= Date(event.start)
            )
          ) {
            return true;
          }
        }
      }
      return false;
    },
  },
};
</script>
<style scoped lang="scss">
$bgcolor: #F8F8F8;
.v-event-draggable {
  padding: 4px;
  text-align: right;
}

.v-event-timed {
  user-select: none;
  -webkit-user-select: none;
}

.v-event-drag-bottom {
  position: absolute;
  left: 0;
  right: 0;
  bottom: 4px;
  height: 4px;
  cursor: ns-resize;

  &::after {
    display: none;
    position: absolute;
    left: 50%;
    height: 4px;
    border-top: 1px solid white;
    border-bottom: 1px solid white;
    width: 16px;
    margin-left: -8px;
    opacity: 0.8;
    content: "";
  }

  &:hover::after {
    display: block;
  }
}
.theme--light.v-toolbar.v-sheet {
  background-color: $bgcolor;
}
.theme--light.v-sheet {
  background-color: $bgcolor;
}
// .theme--light.v-calendar-daily {
//   background-color: $bgcolor;
// }
</style>
